# List Roles

> Source: https://truto.one/docs/api-reference/unified-user-directory-api/roles/list/

`GET /unified/user-directory/roles`

Resource: **Roles** · API: **Unified User Directory API**

## Supported integrations

Adobe, Adobe Marketo Engage, Adyen, Anthropic, Apache Airflow, Apono, Attio, Auth0, Avalara AvaTax, Avigilon Alta, Avoma, Azure Active Directory, Baremetrics, BigPanda, Bitbucket, BlackLine, Boomi, BrowserStack, Buildkite, Canva, Cato Networks, Checkr, Cisco Meraki, ClickUp, Close, Cloudflare, CockroachDB Cloud, Confluent, Constant Contact, CrowdStrike (partial), Dashlane, Datadog, dbt Labs, Discord, Dixa, DocuSign, Domo, Doppler, Drata, Drift, Druva inSync, Duo, Dynatrace, Elastic Cloud, Emburse, Eventbrite, Files.com, Fireflies.ai, Fivetran, Freshcaller, Freshchat, Freshdesk, Freshservice, FuseDesk, GitLab, Gong, Google, Google Ads, Google Cloud, Google Workspace, HappyFox, Harness, Harvest, HelloID, Dropbox Sign (HelloSign), Help Scout, Heroku, Highlevel, HubSpot, Illow, Jamf, Jenkins, JFrog, Jira, Jira Service Management, JumpCloud, juniper-mist, Juniper Mist, KnowBe4, Kommo, Kustomer, LastPass, LaunchDarkly, Leadsquared, LearnWorlds, Looker, Mailersend, Mailgun, Meta Marketing API, Microsoft 365, Mode, Oracle Netsuite, New Relic, Ninjaone, Okta, OneDrive, OneLogin, OnePageCRM, OpenAI, Opsgenie, Oracle Fusion Cloud, Oracle Fusion Cloud EPM, Oracle Fusion Cloud Financials, Outreach, PagerDuty, Pipedrive, Pivotal Tracker, Podio, Podium, Power BI, ProdPad, Pylon, Qdrant Cloud, Qlik Sense, Re:amaze, Redis, Render, Richpanel, Rockset, Sage Intacct, SailPoint IdentityIQ SCIM, SailPoint Identity Security Cloud, SailPoint NERM, Salesforce, Salesloft, Scale AI, Segment, Sendoso, ServiceNow, Showpad, Sisense, Slab, Slack, Slack Enterprise, SmartRecruiters, Smartsheet, Snowflake, Snyk, SolarWinds Service Desk, Sophos, SpotDraft, Statsig, Streak, Sumo Logic, Supabase, Superchat, SurveySparrow, Tableau, TeamViewer, Teamwork Desk, ThoughtSpot, Torii, Trello, Trengo, Turso, UiPath, Vercel, Webex, WordPress, Workato, Workiva, Wrike, Zendesk, Zoho Bigin, Zoho CRM, Zoho Desk, Zoho Meeting, Zoho Projects, Zoom

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`name`** _(string)_
  The name of the role
- **`user_id`** _(string)_
  The unique identifier for the user.
- **`organization_id`** _(string)_
  The unique identifier for an organization
- **`workspace_id`** _(unknown)_
- **`product`** _(string)_
  Select the product for which you want to retrieve the roles.
  Allowed: `azure_active_directory`, `onedrive`, `workspace`
- **`group_id`** _(unknown)_
- **`sort_by`** _(string)_
  The field to sort the resource by. The possible field is `name`.

## Response body

- **`result`** _(array<object>)_
  List of Roles
  - **`id`** _(string, required)_
    The unique identifier for a role
  - **`name`** _(string)_
    The name of the role
  - **`label`** _(string)_
    The display label of the role
  - **`description`** _(string)_
    The description of the role
  - **`type`** _(string)_
    The type of the role
  - **`applicable_in`** _(string)_
    The context in which the role is applicable
    Allowed: `group`, `workspace`
  - **`created_at`** _(string)_
    The date and time the role was created
  - **`updated_at`** _(string)_
    The date and time the role was last updated
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/user-directory/roles?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/user-directory/roles?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/user-directory/roles"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'user-directory',
  'roles',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "user-directory",
        "roles",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
